SUPPORTED DEVICES

Currently supported devices include:
- Antminer U1/U2/U2+/U3 USB
- Antminer S1
- ASICMINER block erupters
- ASICMINER Tube/Prisma
- Avalon (including BitBurner and Klondike)
- Avalon2/3
- Avalon4/4.1/6
- Avalon7
- Avalon8
- BFx2 USB
- Butterfly Labs SC 65/28nm range
- BF1 (bitfury) USB (red and blue)
- BlackArrow Bitfury
- BlackArrow Minion
- Bi*fury USB
- Cointerra
- Compac bitshopperde
- GekkoScience
- Halong Dragonmint T1
- Hashfast Babyjet and Sierra
- Hashratio
- Hexfury USB
- KnCminer Mercury, Saturn and Jupiter
- Nanofury USB
- Other bitfury USB devices
- Onestring miner USB
- Rockminer R-Box/RK-Box/T1/New R-Box
- Spondoolies SP10, SP30


No COM ports on windows or TTY devices will be used by cgminer as it
communicates directly with them via USB so it is normal for them to not exist or
be disconnected when cgminer is running.

The BFL devices should come up as one of the following:

BAJ: BFL ASIC Jalapeño
BAL: BFL ASIC Little Single
BAS: BFL ASIC Single
BAM: BFL ASIC Minirig
BMA: BFL Monarch

BFL devices need the --enable-bflsc option when compiling cgminer yourself.

Avalon will come up as AVA.

Avalon devices need the --enable-avalon option when compiling cgminer.

Avalon2/3 will come up as AV2.

Avalon2/3 devices need the --enable-avalon2 option when compiling cgminer.

Avalon4/4.1 will come up as AV4, Please use the MM version to distinguish.

Avalon6 will come up as AV6.

Avalon4/4.1/6 devies need the --enable-avalon4 option when compiling cgminer.

Avalon7 will come up as AV7.

Avalon8 will come up as AV8.

Klondike will come up as KLN.

Klondike devices need the --enable-klondike option when compiling cgminer.

ASICMINER block erupters will come up as AMU.

ASICMINER devices need the --enable-icarus option when compiling cgminer.
Also note that the AMU is managed by the Icarus driver which is detailed
in the FPGA-README. Configuring them uses the same mechanism as outlined
below for getting started with USB ASICs.

ASICMINER BlockErupter Tube/Prisma will come up as BET.

ASICMINER Tube/Prisma devices need the --enable-blockerupter option when
compiling cgminer. This driver is apparently BROKEN and the original contributor
has not submitted fixes.

BlackArrow Bitfury devices

BlackArrow Bitfury devices need the --enable-bab option when compiling cgminer.

The current BlackArrow Bitfury devices are similar to the Bitfury GPIO mining
boards, with both V1 and V2 controllers, and come up as BaB.


BlackArrow Minion devices

BlackArrow Minion devices need the --enable-minion option when compiling
cgminer.

BlackArrow Minion devices are SPI/GPIO mining devices and come up as MBA


BITFURY devices

Bitfury devices need the --enable-bitfury option when compiling cgminer.

Currently the BPMC/BGMC BF1 devices AKA redfury/bluefury are supported and
come up as BF1, along with the Bi*fury USB devices which come up as BXF.
Nanofury devices come up as NF1. BFx2 devices come up as BXM.

Bitfury USB devices are also set up as per the USB ASICs below.


COINTERRA devices

Cointerra devices need the --enable-cointerra option when compiling cgminer.

Cointerra devices come up as CTA devices and currently take only hidden command
line arguments for power settings.

Cointerra USB devices are set up as per the USB ASIC instructions below.


Compac devices

Bitshopperde compac devices need the --enable-gekko option when compiling cgminer.
This also supports the GekkoScience devices.

bitshopperde come up as BSC, BSD, BSE


GekkoScience devices

GekkoScience devices need the --enable-gekko option when compiling cgminer.
This also supports the bitshopperde devices.

GekkoScience come up as GSC, GSD, GSE, GSF, GSH, GSI


HALONG devices

HALONG Dragonmint T1 devices will come up as DT1.

Halong devices need the --enable-dragonmint_t1 option.




HASHFAST devices

Hashfast devices need the --enable-hashfast option when compiling cgminer.

All current HFA devices are supported and are recognised with the name HFA
in the --usb commands. After initialisation, cgminer will determine what type
they are and give them the following names:

HFB: Hashfast Babyjet
HFS: Hashfast Sierra
HFA: Hashfast non standard (eg. a Babyjet with an added board, Habanero)


HASHRATIO devices

Hashratio devices need the --enable-hashratio option when compiling cgminer.


ANTMINER U1/U2+/U3 devices

Antminer devices need the --enable-icarus option when compiling cgminer.

Currently the U1/2/3 USB sticks are supported and come up as the following
devices:

ANU: Antminer U1/U2/U2+
AU3: Antminer U3

They are also set up as per the USB ASICs below.

ANTMINER S1 devices

Antminer S1 devices need the --enable-ants1 option when compiling cgminer.

They are custom OpenWRT linux devices

They are recognised with the name ANT


BITMINE A1 devices

Bitmine A1 devices need the --enable-bitmine_A1 compile option set.


Rockminer R*Box

Rockminer R*Box devices need the --enable-icarus compile option set.

They appear with the following names:
LIN: R-Box
LIR: New R-Box

---
GETTING STARTED WITH USB ASICS

Unlike other software, cgminer uses direct USB communication instead of the
ancient serial USB communication to be much faster, more reliable and use a
lot less CPU. For this reason, setting up for mining with cgminer on these
devices requires different drivers.


See README 'SETTING UP USB DEVICES' for setting up USB mining with cgminer

---

ASIC SPECIFIC COMMANDS

--anu-freq <arg>    Set AntminerU1/2 frequency in MHz, range 125-500 (default: 250.0)
--au3-freq <arg>    Set AntminerU3 frequency in MHz, range 100-250 (default: 225.0)
--au3-volt <arg>    Set AntminerU3 voltage in mv, range 725-850, 0 to not set (default: 775)
--avalon-auto       Adjust avalon overclock frequency dynamically for best hashrate
--avalon-cutoff <arg> Set avalon overheat cut off temperature (default: 60)
--avalon-fan <arg> Set fanspeed percentage for avalon, single value or range (default: 20-100)
--avalon-freq <arg> Set frequency range for avalon-auto, single value or range
--avalon-options <arg> Set avalon options baud:miners:asic:timeout:freq:tech
--avalon-temp <arg> Set avalon target temperature (default: 50)
--avalon2-freq      Set frequency range for Avalon2, single value or range
--avalon2-voltage   Set Avalon2 core voltage, in millivolts
--avalon2-fan       Set Avalon2 target fan speed
--avalon2-cutoff <arg> Set Avalon2 overheat cut off temperature (default: 88)
--avalon2-fixed-speed Set Avalon2 fan to fixed speed
--avalon4-automatic-voltage Automatic adjust voltage base on module DH
--avalon4-voltage   Set Avalon4 core voltage, in millivolts, step: 125
--avalon4-freq      Set frequency for Avalon4, 1 to 3 values, example: 445:385:370
--avalon4-fan       Set Avalon4 target fan speed range
--avalon4-temp <arg> Set Avalon4 target temperature (default: 42)
--avalon4-cutoff <arg> Set Avalon4 overheat cut off temperature (default: 65)
--avalon4-polling-delay <arg> Set Avalon4 polling delay value (ms) (default: 20)
--avalon4-ntime-offset <arg> Set Avalon4 MM ntime rolling max offset (default: 4)
--avalon4-aucspeed <arg> Set Avalon4 AUC IIC bus speed (default: 400000)
--avalon4-aucxdelay <arg> Set Avalon4 AUC IIC xfer read delay, 4800 ~= 1ms (default: 9600)
--avalon4-miningmode <arg> Set Avalon4 mining mode(0:custom, 1:eco, 2:normal, 3:turbo (default: 0)
--avalon4-freezesafe Make Avalon4 running as a radiator when stratum server failed
--avalon4-ntcb <arg> Set Avalon4 MM NTC B value (default: 3450)
--avalon4-freq-min <arg> Set minimum frequency for Avalon4 (default: 100)
--avalon4-freq-max <arg> Set maximum frequency for Avalon4 (default: 1000)
--avalon4-noncecheck-off Disable A3218 inside nonce check function
--avalon4-smart-speed <arg> Set smart speed, range 0-3. 0 means Disable (default: 2)
--avalon4-speed-bingo <arg> Set A3218 speed bingo for smart speed mode 1 (default: 255)
--avalon4-speed-error <arg> Set A3218 speed error for smart speed mode 1 (default: 3)
--avalon4-least-pll <arg> Set least pll check threshold for smart speed mode 2 (default: 768)
--avalon4-most-pll <arg> Set most pll check threshold for smart speed mode 2 (default: 256)
--avalon7-voltage   Set Avalon7 default core voltage, in millivolts, step: 78
--avalon7-voltage-level Set Avalon7 default level of core voltage, range:[0, 15], step: 1
--avalon7-voltage-offset Set Avalon7 default offset of core voltage, range:[-2, 1], step: 1
--avalon7-freq      Set Avalon7 default frequency, range:[24, 1404], step: 12, example: 500
--avalon7-freq-sel <arg> Set Avalon7 default frequency select, range:[0, 5], step: 1, example: 3 (default: 0)
--avalon7-fan       Set Avalon7 target fan speed, range:[0, 100], step: 1, example: 0-100
--avalon7-temp <arg> Set Avalon7 target temperature, range:[0, 100] (default: 99)
--avalon7-polling-delay <arg> Set Avalon7 polling delay value (ms) (default: 20)
--avalon7-aucspeed <arg> Set AUC3 IIC bus speed (default: 400000)
--avalon7-aucxdelay <arg> Set AUC3 IIC xfer read delay, 4800 ~= 1ms (default: 19200)
--avalon7-smart-speed <arg> Set Avalon7 smart speed, range 0-1. 0 means Disable (default: 1)
--avalon7-th-pass <arg> Set A3212 th pass value (default: 162)
--avalon7-th-fail <arg> Set A3212 th fail value (default: 10921)
--avalon7-th-init <arg> Set A3212 th init value (default: 32767)
--avalon7-th-ms <arg> Set A3212 th ms value (default: 1)
--avalon7-th-timeout <arg> Set A3212 th timeout value (default: 0)
--avalon7-iic-detect Enable Avalon7 detect through iic controller
--avalon7-freqadj-time <arg> Set Avalon7 check interval when run in AVA7_FREQ_TEMPADJ_MODE (default: 60)
--avalon7-delta-temp <arg> Set Avalon7 delta temperature when reset freq in AVA7_FREQ_TEMPADJ_MODE (default: 0)
--avalon7-delta-freq <arg> Set Avalon7 delta freq when adjust freq in AVA7_FREQ_TEMPADJ_MODE (default: 100)
--avalon7-freqadj-temp <arg> Set Avalon7 check temperature when run into AVA7_FREQ_TEMPADJ_MODE (default: 104)
--avalon7-nonce-mask <arg> Set A3212 nonce mask, range 24-32. (default: 31)
--no-avalon7-asic-debug Disable A3212 debug.
--avalon8-voltage-level Set Avalon8 default level of core voltage, range:[0, 15], step: 1
--avalon8-voltage-level-offset Set Avalon8 default offset of core voltage level, range:[-2, 1], step: 1
--avalon8-freq      Set Avalon8 default frequency, range:[25, 1200], step: 25, example: 800
--avalon8-freq-sel <arg> Set Avalon8 default frequency select, range:[0, 3], step: 1, example: 3 (default: 3)
--avalon8-fan       Set Avalon8 target fan speed, range:[0, 100], step: 1, example: 0-100
--avalon8-temp <arg> Set Avalon8 target temperature, range:[0, 100] (default: 90)
--avalon8-polling-delay <arg> Set Avalon8 polling delay value (ms) (default: 20)
--avalon8-aucspeed <arg> Set AUC3 IIC bus speed (default: 400000)
--avalon8-aucxdelay <arg> Set AUC3 IIC xfer read delay, 4800 ~= 1ms (default: 19200)
--avalon8-smart-speed <arg> Set Avalon8 smart speed, range 0-1. 0 means Disable (default: 1)
--avalon8-th-pass <arg> Set A3210 th pass value (default: -1)
--avalon8-th-fail <arg> Set A3210 th fail value (default: -1)
--avalon8-th-init <arg> Set A3210 th init value (default: 32767)
--avalon8-th-ms <arg> Set A3210 th ms value (default: 5)
--avalon8-th-timeout <arg> Set A3210 th timeout value (default: 4294967295)
--avalon8-th-add <arg> Set A3210 th add value (default: 1)
--avalon8-iic-detect Enable Avalon8 detect through iic controller
--avalon8-nonce-mask <arg> Set A3210 nonce mask, range 24-32. (default: -1)
--avalon8-nonce-check <arg> Set A3210 nonce check, range 0-1. (default: 1)
--avalon8-roll-enable <arg> Set A3210 roll enable, range 0-1. (default: 1)
--avalon8-mux-l2h <arg> Set Avalon8 mux l2h, range 0-2. (default: 0)
--avalon8-mux-h2l <arg> Set Avalon8 mux h2l, range 0-1. (default: 1)
--avalon8-h2ltime0-spd <arg> Set Avalon8 h2ltime0 spd, range 0-255. (default: 3)
--avalon8-spdlow <arg> Set Avalon8 spdlow, range 0-3. (default: -1)
--avalon8-spdhigh <arg> Set Avalon8 spdhigh, range 0-3. (default: 3)
--avalon8-cinfo-asic Set Avalon8 cinfo asic index, range:[0, 25], step: 1
--avalon8-pid-p <arg> Set Avalon8 pid-p, range 0-9999. (default: 2)
--avalon8-pid-i <arg> Set Avalon8 pid-i, range 0-9999. (default: 5)
--avalon8-pid-d <arg> Set Avalon8 pid-d, range 0-9999. (default: 0)
--bab-options <arg> Set BaB options max:def:min:up:down:hz:delay:trf
--bet-clk <arg>     Set clockspeed of ASICMINER Tube/Prisma to (arg+1)*10MHz (default: 23)
--bflsc-overheat <arg> Set overheat temperature where BFLSC devices throttle, 0 to disable (default: 90)
--bitburner-fury-options <arg> Override avalon-options for BitBurner Fury boards baud:miners:asic:timeout:freq
--bitburner-fury-voltage <arg> Set BitBurner Fury core voltage, in millivolts
--bitburner-voltage <arg> Set BitBurner (Avalon) core voltage, in millivolts
--bitmain-auto      Adjust bitmain overclock frequency dynamically for best hashrate
--bitmain-cutoff <arg> Set bitmain overheat cut off temperature
--bitmain-fan <arg> Set fanspeed percentage for bitmain, single value or range (default: 20-100)
--bitmain-freq <arg> Set bitmain freq options timeout:freq:regdata
--bitmain-hwerror   Set bitmain device detect hardware error
--bitmain-options <arg> Set bitmain options baud:miners:asic:timeout:freq:regdata
--bitmain-temp <arg> Set bitmain target temperature
--bitmain-workdelay <arg> Set bitmain work delay (ms) 0-100
--bitmain-voltage <arg> Set bitmain voltage - S2/S3 only
--bitmain-dev <arg> Set bitmain device - S2 only
--bitmainbeeper     Set bitmain beeper ringing
--bitmaintempoverctrl Set bitmain stop runing when temprerature is over 80 degree Celsius
--bxf-bits <arg>    Set max BXF/HXF bits for overclocking (default: 54)
--bxf-temp-target <arg> Set target temperature for BXF/HXF devices (default: 82)
--bxm-bits <arg>    Set BXM bits for overclocking (default: 54)
--hfa-hash-clock <arg> Set hashfast clock speed (default: 550)
--hfa-fail-drop <arg> Set how many MHz to drop clockspeed each failure on an overlocked hashfast device (default: 10)
--hfa-fan <arg>     Set fanspeed percentage for hashfast, single value or range (default: 10-85)
--hfa-name <arg>    Set a unique name for a single hashfast device specified with --usb or the first device found
--hfa-noshed        Disable hashfast dynamic core disabling feature
--hfa-options <arg> Set hashfast options name:clock or name:clock@voltage (comma separated)
--hfa-temp-overheat <arg> Set the hashfast overheat throttling temperature (default: 95)
--hfa-temp-target <arg> Set the hashfast target temperature (0 to disable) (default: 88)
--hro-freq          Set the hashratio clock frequency (default: 280)
--klondike-options <arg> Set klondike options clock:temptarget
--minion-chipreport <arg> Seconds to report chip 5min hashrate, range 0-100 (default: 0=disabled)
--minion-freq <arg> Set minion chip frequencies in MHz, single value or comma list, range 100-1400 (default: 1200)
--minion-freqchange Millisecond total time to do frequency changes (default: 1000)
--minion-freqpercent Percentage to use when starting up a chip (default: 70%)
--minion-idlecount  Report when IdleCount is >0 or changes
--minion-ledcount   Turn off led when more than this many chips below the ledlimit (default: 0)
--minion-ledlimit   Turn off led when chips GHs are below this (default: 90)
--minion-idlecount  Report when IdleCount is >0 or changes
--minion-noautofreq Disable automatic frequency adjustment
--minion-overheat   Enable directly halting any chip when the status exceeds 100C
--minion-spidelay   Add a delay in microseconds after each SPI I/O
--minion-spireset   SPI regular reset: iNNN for I/O count or sNNN for seconds - 0 means none
--minion-spisleep   Sleep time in milliseconds when doing an SPI reset
--minion-temp <arg> Set minion chip temperature threshold, single value or comma list, range 120-160 (default: 135C)
--nfu-bits <arg>    Set nanofury bits for overclocking, range 32-63 (default: 50)
--rock-freq <arg>   Set RockMiner frequency in MHz, range 125-500 (default: 270)


ANTMINER S1 DEVICES

--bitmain-auto      Adjust bitmain overclock frequency dynamically for best hashrate
--bitmain-cutoff    Set bitmain overheat cut off temperature
--bitmain-fan       Set fanspeed percentage for bitmain, single value or range (default: 20-100)
--bitmain-freq      Set frequency range for bitmain-auto, single value or range
--bitmain-hwerror   Set bitmain device detect hardware error
--bitmain-options   Set bitmain options baud:miners:asic:timeout:freq
--bitmain-temp      Set bitmain target temperature

The Antminer S1 device comes with its own operating system and a preinstalled
version of cgminer as part of the flash firmware. No configuration should be
necessary.


ANTMINER U1/2/3 DEVICES

--anu-freq <arg>    Set AntminerU1 frequency in MHz, range 150-500 (default: 200)
--au3-freq <arg>    Set AntminerU3 frequency in MHz, range 100-250 (default: 225.0)
--au3-volt <arg>    Set AntminerU3 voltage in mv, range 725-850, 0 to not set (default: 750)

By default, Antminer U1 devices run at a clockspeed of 200. This command allows
you to specify a chosen frequency to attempt to run all ANU devices at. Cgminer
will try to find the nearest frequency the device supports and will report if
the frequency is not exactly as requested. Note that cgminer reports hashrate
ONLY FROM VALID HASHES so if you increase the frequency but your hashrate does
not increase or it decreases and hardware errors start showing up, you have
overclocked it too much. In the worst case scenario it will fail to start at too
high a speed. Most will run happily up to 250.

ASICMINER BlockErupter Tube/Prisma DEVICES

--bet-clk <arg>     Set clockspeed of ASICMINER Tube/Prisma to (arg+1)*10MHz (default: 23)

Default clockspeed for Tube/Prisma is 240MHz. This command allows to set clockspeed
of on board BE200 chips in range from 200MHz to 320MHz. For Tube devices, you can
try overclocking to 270MHz or even higher, but NOT recommended for Prisma devices.
If you notice hash rate drops or board fails to start, restart cgminer with lower
clockspeed.


AVALON AND BITBURNER DEVICES

Currently all known Avalon devices come with their own operating system and
a preinstalled version of cgminer as part of the flash firmware, based on the
most current cgminer version so no configuration should be necessary. It is
possible to plug a USB cable from a PC into the Avalon device and mine using
cgminer as per any other device. It will autodetect and hotplug using default
options. You can customise the avalon behaviour by using the avalon-options
command, and adjust its fan control-temperature relationship with avalon-temp.
By default the avalon will also cut off when its temperature reaches 60
degrees.

All current BitBurner devices (BitBurner X, BitBurner XX and BitBurner Fury)
emulate Avalon devices, whether or not they use Avalon chips.

Avalon commands:

--avalon-auto       Adjust avalon overclock frequency dynamically for best hashrate
--avalon-cutoff <arg> Set avalon overheat cut off temperature (default: 60)
--avalon-fan <arg> Set fanspeed percentage for avalon, single value or range (default: 20-100)
--avalon-freq <arg> Set frequency range for avalon-auto, single value or range
--avalon-options <arg> Set avalon options baud:miners:asic:timeout:freq:tech
--avalon-temp <arg> Set avalon target temperature (default: 50)
--bitburner-fury-options <arg> Override avalon-options for BitBurner Fury boards baud:miners:asic:timeout:freq
--bitburner-fury-voltage <arg> Set BitBurner Fury core voltage, in millivolts
--bitburner-voltage <arg> Set BitBurner (Avalon) core voltage, in millivolts


Avalon auto will enable dynamic overclocking gradually increasing and
decreasing the frequency till the highest hashrate that keeps hardware errors
under 2% is achieved. This WILL run your avalon beyond its normal specification
so the usual warnings apply. When avalon-auto is enabled, the avalon-options
for frequency and timeout are used as the starting point only.

eg:
--avalon-fan 50
--avalon-fan 40-80

By default the avalon fans will be adjusted to maintain a target temperature
over a range from 20 to 100% fanspeed. avalon-fan allows you to limit the
range of fanspeeds to a single value or a range of values.

eg:
--avalon-freq 300-350

In combination with the avalon-auto command, the avalon-freq command allows you
to limit the range of frequencies which auto will adjust to.

eg:
--avalon-temp 55

This will adjust fanspeed to keep the temperature at or slightly below 55.
If you wish the fans to run at maximum speed, setting the target temperature
very low such as 0 will achieve this. This option can be added to the "More
options" entry in the web interface if you do not have a direct way of setting
it.

eg:
--avalon-cutoff 65

This will cut off the avalon should it get up to 65 degrees and will then
re-enable it when it gets to the target temperature as specified by avalon-temp.

eg:
--avalon-options 115200:24:10:D:1500:55

The values are baud : miners : asic count : timeout : frequency : technology.

Baud:
The device is pretty much hard coded to emulate 115200 baud so you shouldn't
change this.

Miners:
Most Avalons are 3 module devices, which come to 24 miners. 4 module devices
would use 32 here.

For BitBurner X and BitBurner XX devices you should use twice the number of
boards in the stack.  e.g. for a two-board stack you would use 4.  For
BitBurner Fury devices you should use the total number of BitFury chips in the
stack (i.e. 16 times the number of boards).  e.g. for a two-board stack you
would use 32.

Asic count:
Virtually all have 10, so don't change this.  BitBurner devices use 10 here
even if the boards have some other number of ASICs.

Timeout:
This is how long the device will work on a work item before accepting new work
to replace it. It should be changed according to the frequency (last setting).
It is possible to set this a little lower if you are trying to tune for short
block mining (eg p2pool) but much lower and the device will start creating
duplicate shares.
A value of 'd' means cgminer will calculate it for you based on the frequency
and is highly recommended.

Sample settings for valid different frequencies (last 3 values) for 110nm AVAs:
34:375:110 *
36:350:110 *
43:300:110
45:282:110 (default)
50:256:110

Note that setting a value with an asterisk next to it will be using your
avalon outside its spec and you do so at your own risk.

For 55nm AVAs, the usual values are 8:1500

Frequency:
This is the clock speed of the devices. For Avalon 110nm devices, values from
256 upwards are valid with the default being 282 and the maximum practical
being approximately 350. For 55nm devices values from 1000-2000 are valid with
1500 being the default.

Technology:
What sized technology ASICs are in use in the avalon, choices are 55 or 110,
corresponding to the nm technology chips in use.

The default frequency for BitBurner X and BitBurner XX boards is 282.  The
default frequency for BitBurner Fury boards is 256.  Overclocking is
possible - please consult the product documentation and/or manufacturer for
information on safe values.  Values outside this range are used at your own
risk.  Underclocking is also possible, at least with the X and XX boards.

eg:
--bitburner-fury-options <arg> Override avalon-options for BitBurner Fury boards baud:miners:asic:timeout:freq

This option takes the same format as --avalon-options.  When specified, it
will be used for BitBurner Fury boards in preference to the values specified
in --avalon-options.  (If not specified, BitBurner Fury boards will be
controlled by the values used in --avalon options.)  See --avalon-options for
a detailed description of the fields.

This option is particularly useful when using a mixture of different BitBurner
devices as BitBurner Fury devices generally require significantly different
clock frequencies from Avalon-based devices.  This option is only available
for boards with recent firmware that are recognized by cgminer as BBF.

eg:
--bitburner-fury-voltage <arg> Set BitBurner Fury core voltage, in millivolts

Sets the core voltage for the BitBurner Fury boards.  The default value is
900.  Overvolting is possible - please consult the product documentation
and/or manufaturer about the safe range of values.  Values outside this range
are used at your own risk.

This option is only available for boards with recent firmware that are
recognized by cgminer as BBF.  For boards recognized as BTB, see
--bitburner-voltage

eg:
--bitburner-voltage <arg> Set BitBurner (Avalon) core voltage, in millivolts

Sets the core voltage for the Avalon-based BitBurner X and BitBurner XX
boards.  The default value is 1200.  Overvolting and undervolting is
possible - please consult the product documentation and/or the manufacturer
for information about the safe range.  Values outside this range are used at
your own risk.

Older BitBurner Fury firmware emulates a BitBurner XX board and is identified
by cgminer as BTB.  On these devices, --bitburner-voltage is used to control
the voltage of the BitBurner Fury board.  The actual core voltage will be
300mV less than the requested voltage, so to run a BitBurner Fury board at
950mV use --bitburner-voltage 1250.  The default value of 1200 therefore
corresponds to the default core voltage of 900mV.


If you use the full curses based interface with Avalons you will get this
information:
AVA 0: 22/ 46C  2400R

The values are:
ambient temp / highest device temp  lowest detected ASIC cooling fan RPM.

Use the API for more detailed information than this.


Avalon2 Devices

--avalon2-freq      Set frequency range for Avalon2, single value or range
--avalon2-voltage   Set Avalon2 core voltage, in millivolts
--avalon2-fan       Set Avalon2 target fan speed
--avalon2-cutoff <arg> Set Avalon2 overheat cut off temperature (default: 88)
--avalon2-fixed-speed Set Avalon2 fan to fixed speed


Avalon4 Devices

--avalon4-automatic-voltage Automatic adjust voltage base on module DH
--avalon4-voltage   Set Avalon4 core voltage, in millivolts, step: 125
--avalon4-freq      Set frequency for Avalon4, 1 to 3 values, example: 445:385:370
--avalon4-fan       Set Avalon4 target fan speed range
--avalon4-temp <arg> Set Avalon4 target temperature (default: 42)
--avalon4-cutoff <arg> Set Avalon4 overheat cut off temperature (default: 65)
--avalon4-polling-delay <arg> Set Avalon4 polling delay value (ms) (default: 20)
--avalon4-ntime-offset <arg> Set Avalon4 MM ntime rolling max offset (default: 4)
--avalon4-aucspeed <arg> Set Avalon4 AUC IIC bus speed (default: 400000)
--avalon4-aucxdelay <arg> Set Avalon4 AUC IIC xfer read delay, 4800 ~= 1ms (default: 9600)
--avalon4-miningmode <arg> Set Avalon4 mining mode(0:custom, 1:eco, 2:normal, 3:turbo (default: 0)
--avalon4-freezesafe Make Avalon4 running as a radiator when stratum server failed
--avalon4-ntcb <arg> Set Avalon4 MM NTC B value (default: 3450)
--avalon4-freq-min <arg> Set minimum frequency for Avalon4 (default: 100)
--avalon4-freq-max <arg> Set maximum frequency for Avalon4 (default: 1000)
--avalon4-noncecheck-off Disable A3218 inside nonce check function
--avalon4-smart-speed <arg> Set smart speed, range 0-3. 0 means Disable (default: 2)
--avalon4-speed-bingo <arg> Set A3218 speed bingo for smart speed mode 1 (default: 255)
--avalon4-speed-error <arg> Set A3218 speed error for smart speed mode 1 (default: 3)
--avalon4-least-pll <arg> Set least pll check threshold for smart speed mode 2 (default: 768)
--avalon4-most-pll <arg> Set most pll check threshold for smart speed mode 2 (default: 256)

Avalon7 Devices

--avalon7-voltage   Set Avalon7 default core voltage, in millivolts, step: 78
--avalon7-voltage-level Set Avalon7 default level of core voltage, range:[0, 15], step: 1
--avalon7-voltage-offset Set Avalon7 default offset of core voltage, range:[-2, 1], step: 1
--avalon7-freq      Set Avalon7 default frequency, range:[24, 1404], step: 12, example: 500
--avalon7-freq-sel <arg> Set Avalon7 default frequency select, range:[0, 5], step: 1, example: 3 (default: 0)
--avalon7-fan       Set Avalon7 target fan speed, range:[0, 100], step: 1, example: 0-100
--avalon7-temp <arg> Set Avalon7 target temperature, range:[0, 100] (default: 99)
--avalon7-polling-delay <arg> Set Avalon7 polling delay value (ms) (default: 20)
--avalon7-aucspeed <arg> Set AUC3 IIC bus speed (default: 400000)
--avalon7-aucxdelay <arg> Set AUC3 IIC xfer read delay, 4800 ~= 1ms (default: 19200)
--avalon7-smart-speed <arg> Set Avalon7 smart speed, range 0-1. 0 means Disable (default: 1)
--avalon7-th-pass <arg> Set A3212 th pass value (default: 162)
--avalon7-th-fail <arg> Set A3212 th fail value (default: 10921)
--avalon7-th-init <arg> Set A3212 th init value (default: 32767)
--avalon7-th-ms <arg> Set A3212 th ms value (default: 1)
--avalon7-th-timeout <arg> Set A3212 th timeout value (default: 0)
--avalon7-iic-detect Enable Avalon7 detect through iic controller
--avalon7-freqadj-time <arg> Set Avalon7 check interval when run in AVA7_FREQ_TEMPADJ_MODE (default: 60)
--avalon7-delta-temp <arg> Set Avalon7 delta temperature when reset freq in AVA7_FREQ_TEMPADJ_MODE (default: 0)
--avalon7-delta-freq <arg> Set Avalon7 delta freq when adjust freq in AVA7_FREQ_TEMPADJ_MODE (default: 100)
--avalon7-freqadj-temp <arg> Set Avalon7 check temperature when run into AVA7_FREQ_TEMPADJ_MODE (default: 104)
--avalon7-nonce-mask <arg> Set A3212 nonce mask, range 24-32. (default: 31)
--no-avalon7-asic-debug Disable A3212 debug.

Avalon8 Devices

--avalon8-voltage-level Set Avalon8 default level of core voltage, range:[0, 15], step: 1
--avalon8-voltage-level-offset Set Avalon8 default offset of core voltage level, range:[-2, 1], step: 1
--avalon8-freq      Set Avalon8 default frequency, range:[25, 1200], step: 25, example: 800
--avalon8-freq-sel <arg> Set Avalon8 default frequency select, range:[0, 3], step: 1, example: 3 (default: 3)
--avalon8-fan       Set Avalon8 target fan speed, range:[0, 100], step: 1, example: 0-100
--avalon8-temp <arg> Set Avalon8 target temperature, range:[0, 100] (default: 90)
--avalon8-polling-delay <arg> Set Avalon8 polling delay value (ms) (default: 20)
--avalon8-aucspeed <arg> Set AUC3 IIC bus speed (default: 400000)
--avalon8-aucxdelay <arg> Set AUC3 IIC xfer read delay, 4800 ~= 1ms (default: 19200)
--avalon8-smart-speed <arg> Set Avalon8 smart speed, range 0-1. 0 means Disable (default: 1)
--avalon8-th-pass <arg> Set A3210 th pass value (default: -1)
--avalon8-th-fail <arg> Set A3210 th fail value (default: -1)
--avalon8-th-init <arg> Set A3210 th init value (default: 32767)
--avalon8-th-ms <arg> Set A3210 th ms value (default: 5)
--avalon8-th-timeout <arg> Set A3210 th timeout value (default: 4294967295)
--avalon8-th-add <arg> Set A3210 th add value (default: 1)
--avalon8-iic-detect Enable Avalon8 detect through iic controller
--avalon8-nonce-mask <arg> Set A3210 nonce mask, range 24-32. (default: -1)
--avalon8-nonce-check <arg> Set A3210 nonce check, range 0-1. (default: 1)
--avalon8-roll-enable <arg> Set A3210 roll enable, range 0-1. (default: 1)
--avalon8-mux-l2h <arg> Set Avalon8 mux l2h, range 0-2. (default: 0)
--avalon8-mux-h2l <arg> Set Avalon8 mux h2l, range 0-1. (default: 1)
--avalon8-h2ltime0-spd <arg> Set Avalon8 h2ltime0 spd, range 0-255. (default: 3)
--avalon8-spdlow <arg> Set Avalon8 spdlow, range 0-3. (default: -1)
--avalon8-spdhigh <arg> Set Avalon8 spdhigh, range 0-3. (default: 3)
--avalon8-cinfo-asic Set Avalon8 cinfo asic index, range:[0, 25], step: 1
--avalon8-pid-p <arg> Set Avalon8 pid-p, range 0-9999. (default: 2)
--avalon8-pid-i <arg> Set Avalon8 pid-i, range 0-9999. (default: 5)
--avalon8-pid-d <arg> Set Avalon8 pid-d, range 0-9999. (default: 0)

BFLSC Devices

--bflsc-overheat <arg> Set overheat temperature where BFLSC devices throttle, 0 to disable (default: 90)

This will allow you to change or disable the default temperature where cgminer
throttles BFLSC devices by allowing them to temporarily go idle.


BITFURY Devices

--bxf-bits <arg>    Set max BXF/HXF bits for overclocking (default: 54)

In combination with the dynamic clocking on Bi*fury devices, this sets the
highest bit target that cgminer will aim for.


--bxf-temp-target <arg> Set target temperature for BXF/HXF devices (default: 82)

Cgminer uses dynamic clocking on Bi*fury devices to try and maintain the
temperature just below an optimal target. This option allows you to change the
target temperature. When actively cooled below this, the devices will run at
maximum speed.

--bxm-bits <arg>    Set BXM bits for overclocking (default: 54)

Choose the overclocking  bits for BFx2 devices.


--nfu-bits <arg>    Set nanofury bits for overclocking range 32-63 (default: 50)

Cgminer by default sets the clockspeed on nanofury devices to the highest that
is still within USB2 spec. This value allows you to alter the clockspeed, with
~54 being the optimal but requiring a higher power or USB3 port.


Cointerra Devices

--cta-load <arg> (0 - 255)
--ps-load <arg> (0 - 100)

These are undocumented.


Drillbit Systems Devices

--drillbit-options <arg> Set drillbit options <int|ext>:clock[:clock_divider][:voltage]

* int/ext defines the clock source - default int. Not all boards support ext.
* clock_divider must be 1 or 2 with a default of 1. Bitfury only,
  ignored on Avalon.
* clock is in MHz, on Drillbit range 80-250 with a default of 200,
  recommended maximum 230. On Avalon range 500-1000 with a
  recommended maximum of 800.
* voltage is ASIC core voltage in millivolts, available values vary per board but
  default is 850 and the recommended maximum is 950 (Bitfury) and 1000 (Avalon.)

--drillbit-auto <every>:[<gooderr>:<baderr>:<maxerr>]

If supported by firmware and device, this feature allows cgminer to
automatically tweak each ASIC's clock rate up and down in to achieve
optimal performance.

* every - only required param, check each ASIC after each block of
  this many work units. Recommended value 100.
* gooderr - the "Good" threshold is when less hardware errors than
  this per "every" work units, the clock rate will be increased.
  Default value 1.
* baderr - the "Bad" threshold is when more hardware errors than
  this per "every" work units, the clock rate will be decreased.
  Default value 3.
* maxerr - the "Max" threshold is when more hardware errors than
  this per "every" work units (including pre-empting before
  "every" work units is up), the clock rate will be decreased and
  will not be increased again past this point. Default value 10.


BlackArrow Bitfury devices

--bab-options <arg> Set BaB options Max:Def:Min:Up:Down:Hz:Delay:Trf

Any option left blank or starting with 'd' will use the default setting
If there are not enough options, then the remaining will be left at their
default value

Max:Def:Min are the chip speed limits to allow, ranging from 52 to 57

Up:Down are the HW error % used to tune the chip speed
Up means if the HW error % is less than up, over a 5 minute period,
then increase the chip speed
Down means if the HW error % is greater than down, over 5 minutes,
then decrease the chip speed

Hz is the SPI clock speed to use

Delay is the us delay used between bytes for the SPI I/O - default 0

Trf is the us delay used between sends for the SPI I/O - default 0


Hashfast devices

--hfa-hash-clock <arg> Set hashfast clock speed (default: 550)

This will change the initialisation clock speed on all attached hfa devices.
Note that if instability is detected by cgminer and the device has to undergo
a reset, cgminer will lower the clockspeed on resetting it each time till the
value returns to the default of 550.

--hfa-fail-drop <arg> Set how many MHz to drop clockspeed each failure on an overlocked hashfast device (default: 10)

If you overclock your hashfast device with --hfa-hash-clock and cgminer detects
it failing to return hashes, it will restart it at a lower clock speed if
possible. Changing this value will allow you to choose how much it will lower
the clock speed or to disable this function entirely.

--hfa-fan <arg>     Set fanspeed percentage for hashfast, single value or range (default: 10-85)

This changes the range of fanspeeds used on hashfast devices with firmware that
supports it. Note that the fanspeed will dynamically change to try and maintain
a target temperature with --hfa-temp-target but if the target temperature is
disabled, the fanspeed will remain static.
eg:
--hfa-fan 25-100

--hfa-temp-overheat <arg> Set the hashfast overheat throttling temperature (default: 95)

Cgminer will temporarily stop sending hashfast devices work once this
temperature is reached. Note that with the water cooling in these devices,
temperature recovery is likely to be very quick and the device will start
hashing again after only a very brief period.

--hfa-temp-target <arg> Set the hashfast target temperature (0 to disable) (default: 88)

On hashfast devices with firmware that supports dynamic fanspeed and die speeds,
cgminer will try to maintain temperature according to this target by adjusting
fanspeed and then if need be, throttle speeds on a die-by-die basis. Disabling
this feature will leave a constant fanspeed and die speed but will not disable
the temp-overheat feature.

--hfa-name <arg>    Set a unique name for a single hashfast device specified with --usb or the first device found

This command allows you to specify the unique name stored in nvram on a single
hashfast device. This name can be queried from the API stats command and comes
up as "op name". Discrete names are used by cgminer to try to maintain settings
across restarts, unplugs/hotplugs and so on. If this command is used by itself,
the name will be given to the first hashfast device it encounters and then
cgminer will proceed to go back to regular mining. If you have multiple devices,
it is best to discretely choose the device you wish to use with the --usb
command. For example
'lsusb' on linux shows the following devices (297c:0001 is a hfa device):
 Bus 001 Device 079: ID 297c:0001
 Bus 004 Device 042: ID 297c:0001
If you wished to name the second device Slug you would add the commands:
 --hfa-name Slug --usb 4:42

--hfa-noshed        Disable hashfast dynamic core disabling feature

Newer firmwares on hashfast devices dynamically disable cores that generate
invalid data. This command will disable this feature where possible.

--hfa-options <arg> Set hashfast options name:clock or clock@voltage (comma separated)

This command allows you to set options for each discrete hashfast device by
its name (if the firmware has naming support, i.e. version 0.3+). Currently
this takes as option the clock speed alone or clock speed and voltage,
although future options may be added.
e.g.:
--hfa-options "rabbit:650,turtle:550@800"

Would set a device named rabbit to clock speed 650 MHz using default voltage
and the one named turtle to 550 MHz using a voltage of 800 mv. Starting the
device at a speed where it is most stable will give more reliable hashrates
long term and prevent it interacting with other devices, rather than depending
on the clockdown feature in cgminer.

Note: Setting voltage cause a board reset and hotplug event on cgminer startup.

Other undocumented hashfast command line options are for development purposes
only at this stage and serve no useful purpose to end users.


Hashratio Devices

--hro-freq          Set the hashratio clock frequency (default: 280)


Bitmine A1 Devices

--bitmine-a1-options <ref_clk>:<sys_clk>:<spi_clk>:<max_chip>
ref_clk:  reference clock in kHz                      (default: 16000)
sys_clk:  target system clock in kHz to be set in PLL (default: 250000)
spi_clk:  SPI clock in kHz                            (default: 800)
max_chip: [debug/testing] limit chip chain

Set 0 for fields you want to keep untouched to default, e.g.
--bitmine-a1-options 0:0:400
to only set SPI clock to 400kHz


Rockminer R-Box Devices

--rock-freq <arg>   Set RockMiner frequency in MHz, range 125-500 (default: 270)

Note that only a limited range is likely to be accepted (usually 200-290)

